!
! Copyright (c) 2014 Yoshihide Yoshimoto
!
! call S. Grimme dftd3 program
!
module dftd3_sg
  public :: fdftd3
  
contains
  !
  subroutine fdftd3sg(verdftd,xctp,nkd,bspots,aa,nsi,kd,asi,eng,seng,cforce, &
       myrank,comm)
    use bsplpot
    use util
    use mpi
    implicit none
    integer:: verdftd, xctp, nkd
    type (bspot_for_atm):: bspots(nkd)
    real(kind=8),intent(in):: aa(3,3)
    integer,intent(in):: nsi,kd(nsi)
    real(kind=8),intent(in):: asi(3,nsi)
    real(kind=8),intent(out):: eng,seng(6),cforce(3,nsi)
    integer:: myrank,comm

    integer:: it,ierr
    integer,allocatable:: iz(:)
    character(len=80):: xcname

    if (myrank.ne.0) then
       call MPI_BCAST(eng,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
       call MPI_BCAST(seng,6,MPI_DOUBLE_PRECISION,0,comm,ierr)
       call MPI_BCAST(cforce,3*nsi,MPI_DOUBLE_PRECISION,0,comm,ierr)
       return
    end if
    allocate(iz(nsi))
    do it=1,nsi
       iz(it) = nint(bspots(kd(it))%zn)
    end do

    select case (xctp)
    case(1)
       xcname = 'pbe'
    case(2)
       xcname = 'pbesol'
    case(6)
       xcname = 'hf'
    case(7)
       xcname = 'pbe0'
    case(9)
       xcname = 'b3-lyp'
    case default
       write(6,*) 'invalid xctp for DFTD3'
       call MPI_ABORT(MPI_COMM_WORLD,1,ierr)
       stop
    end select

    call ext_dftd3sg(xcname,verdftd,nsi,aa,asi,iz,eng,cforce,seng)

    call MPI_BCAST(eng,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
    call MPI_BCAST(seng,6,MPI_DOUBLE_PRECISION,0,comm,ierr)
    call MPI_BCAST(cforce,3*nsi,MPI_DOUBLE_PRECISION,0,comm,ierr)

    deallocate(iz)

    return
  end subroutine fdftd3sg

end module dftd3_sg
