!
! Copyright (c) 2000-2015 Yoshihide Yoshimoto
!
module mdmuca
  type mbmt_struct
     integer:: ibsrk,nknote,nknotv,neng,nvol
     real(kind=8):: kbt,pext
     real(kind=8):: engmin,deleng,volmin,delvol
     real(kind=8),pointer:: gzaie(:),gzaiv(:)
     real(kind=8),pointer:: entropy(:,:),dsde(:,:),dsdv(:,:)
     logical:: ifmbmt
     real(kind=8),pointer:: deltae(:,:),deltav(:,:)
     real(kind=8),pointer:: conste(:),constv(:)
     real(kind=8),pointer:: fentrpy(:,:),beng(:),bvol(:)
     integer,pointer:: histogr(:,:),hstoavd(:,:)
     integer:: rstat,rnmbr
     integer,pointer:: lstvis(:,:), cntvis(:,:)
     real(kind=8):: maxentrp,minentrp
  end type mbmt_struct

  real(kind=8),private:: mo_ord_max = 32.0d0
  !real(kind=8),private:: mo_ord_alf = log(2.0d0/3.0d0)/log(0.5d0)
  real(kind=8),private:: mo_ord_alf = 0.584962500721156d0

  real(kind=8),private:: wla_limthr = -400.0d0
  real(kind=8),private:: wla_wgt_freqlim = 2.0d0
  real(kind=8),private:: wla_wgt_stathr1 = 1.0d0
  real(kind=8),private:: wla_wgt_stathr2 = 7.0d0
  real(kind=8),private:: wla_fac_freqlim = 5.0d0
  real(kind=8),private:: wla_fac_thr1 = 0.8d0
  real(kind=8),private:: wla_fac_thr2 = 0.1d0

  integer,private:: nspecg, mspecg, navoidg, kdspec
  integer,private,allocatable:: speckg(:,:),avoidg(:,:)

  integer,private:: mo_avd_pwr
  real(kind=8),private:: mo_avd_alp
  real(kind=8),private:: mo_avd_mf
  real(kind=8),private:: mo_avd_thr
  real(kind=8),private:: mo_avd_ord_lim

contains
  subroutine loadmbmt(nfile,syskbt,syspext,mbmts,mssg)
    use bspline
    use mpi
    use iounit
    implicit none
    type (mbmt_struct):: mbmts
    integer,intent(in):: nfile,mssg
    real(kind=8),intent(in):: syskbt,syspext

    integer:: irnk,nknote,nknotv,neng,nvol,ierr
!soption contarea(gzaie,gzaiv,dsde,dsdv)
    real(kind=8),pointer:: gzaie(:),gzaiv(:),dsde(:,:),dsdv(:,:)
!soption contarea(deltae,deltav,conste,constv)
    real(kind=8),pointer:: deltae(:,:),deltav(:,:),conste(:),constv(:)
!soption contarea(entropy)
    real(kind=8),pointer:: entropy(:,:)
!soption contarea(fentrpy,beng,bvol)
    real(kind=8),pointer:: fentrpy(:,:),beng(:),bvol(:)

    integer:: i,j
    real(kind=8):: sentrp
    integer:: ios

    return
  end subroutine loadmbmt

  subroutine storembmt(nfile,mbmts)
    use iounit
    implicit none
    type (mbmt_struct):: mbmts
    integer,intent(in):: nfile

    call xrewind(nfile)
    write(nfile) mbmts%ibsrk,mbmts%nknote,mbmts%nknotv, &
         mbmts%neng,mbmts%nvol
    write(nfile) mbmts%engmin,mbmts%deleng,mbmts%volmin,mbmts%delvol
    write(nfile) mbmts%gzaie, mbmts%gzaiv, mbmts%entropy
    write(nfile) mbmts%kbt,mbmts%pext
    write(nfile) mbmts%histogr
    write(nfile) mbmts%rstat,mbmts%rnmbr
    write(nfile) mbmts%lstvis,mbmts%cntvis
    write(nfile) mbmts%hstoavd

    return
  end subroutine storembmt

  subroutine nullmbmt(mbmts)
    implicit none
    type (mbmt_struct):: mbmts

    mbmts%ibsrk = 0
    mbmts%nknote = 0
    mbmts%nknotv = 0
    mbmts%neng = 0
    mbmts%nvol = 0
    mbmts%ifmbmt = .false.
    return
  end subroutine nullmbmt

  subroutine rdpmuca(nfin,mssg)
    use mpi
    implicit none
    integer,intent(in):: nfin,mssg
    integer:: i,ios
    character(len=256):: buf

    return
  end subroutine rdpmuca
end module mdmuca
