C
C Copyright (c) 1983-2000 TAPP Consortium
C

#define NEW_TETRAHEDRON

C*****************************************************************
C     1993-05-23
C     1995-05-06 P2 part Added
C  last modified at 1995-06-06 iif and irf are introduced
C
C  FERMI DISTRIBUTION FOR A SINGLE SAMPLING K-POINT
C     NKS=1: POPULATION OF ELECTRONS IS SUBJECT TO FERMI DIST.
C                      WITH k_B T=EKBT
C        >1: CALL USUAL subroutine DOS
C**************************************************************
C  From here  'P2' part
C**************************************************************
      subroutine edef(pe,emesh1,emesh2,nsy,kz
     &               ,ndx,ndy,ndz,nb1,nb2,nkr,nng)
      implicit none
      integer ndx,ndy,ndz,nb1,nb2,nkr,nng
      double precision emesh1,emesh2,pe
      dimension emesh1(  -ndx:ndx,    -ndy:ndy,  0:ndz  ,nb1:nb2)
      dimension emesh2(-ndx*2:ndx*2,-ndy*2:ndy*2,0:ndz*2,nb1:nb2)
      dimension pe(nkr,nb1:nb2)
      integer kz(3,nkr,nng),nsy(nkr)
C
      call meshe(pe,emesh1,kz,nsy
     &          ,ndx,ndy,ndz,nkr,nb1,nb2,nng)
      call meshe(pe,emesh2,kz,nsy
     &          ,ndx*2,ndy*2,ndz*2,nkr,nb1,nb2,nng)
C
      return
      end
C*********************************************************************
      subroutine meshe(pe,emesh,kz,nsy
     &                ,ndx,ndy,ndz,nkr,nb1,nb2,nng)
      implicit none
      integer:: ndx,ndy,ndz,nkr,nb1,nb2,nng
      real(kind=8):: pe(nkr,nb1:nb2)
      real(kind=8):: emesh(-ndx:ndx,-ndy:ndy,0:ndz,nb1:nb2)
      integer:: kz(3,nkr,nng),nsy(nkr)
      real(kind=8):: p2
      parameter (p2=6.28318530717958648d0)

      integer:: ib,ix,iy,iz,isy,k
      real(kind=8):: x,y,z,adx,ady,adz

      real(kind=8):: cosmsh(-ndx:ndx,-ndy:ndy,0:ndz)
      real(kind=8):: cxmsh(-ndx:ndx),cymsh(-ndy:ndy),czmsh(0:ndz)
      real(kind=8):: sxmsh(-ndx:ndx),symsh(-ndy:ndy),szmsh(0:ndz)
C
      emesh=0.0d0
C
      adx=p2/dble(2*ndx)
      ady=p2/dble(2*ndy)
      adz=p2/dble(2*ndz)

      do k=1,nkr
        cosmsh = 0.0d0
        do isy=1,nsy(k)
          do ix=-ndx,ndx
            x=adx*ix
            cxmsh(ix)=cos(x*kz(1,k,isy))
            sxmsh(ix)=sin(x*kz(1,k,isy))
          end do
          do iy=-ndy,ndy
            y=ady*iy
            cymsh(iy)=cos(y*kz(2,k,isy))
            symsh(iy)=sin(y*kz(2,k,isy))
          end do
          do iz=0,ndz
            z=adz*iz
            czmsh(iz)=cos(z*kz(3,k,isy))
            szmsh(iz)=sin(z*kz(3,k,isy))
          end do
!$omp parallel do private(ix,iy,iz)
          do iz=0,ndz
            do iy=-ndy,ndy
              do ix=-ndx,ndx
C                x=adx*ix
C                y=ady*iy
C                z=adz*iz
C                cosmsh(ix,iy,iz) = cosmsh(ix,iy,iz)+
C     &               cos(x*kz(1,k,isy)+y*kz(2,k,isy)+z*kz(3,k,isy))
                cosmsh(ix,iy,iz) = cosmsh(ix,iy,iz)
     &               + cxmsh(ix)*cymsh(iy)*czmsh(iz)
     &               - cxmsh(ix)*symsh(iy)*szmsh(iz)
     &               - sxmsh(ix)*cymsh(iy)*szmsh(iz)
     &               - sxmsh(ix)*symsh(iy)*czmsh(iz)
              end do
            end do
          end do
        end do
!$omp parallel do private(ib)
        do ib=nb1,nb2
          emesh(:,:,:,ib) = emesh(:,:,:,ib) + cosmsh*pe(k,ib)
        end do
      end do
      return
      end
C*********************************************************************
      subroutine fermi(emesh1,emesh2,ef
     &     ,ndx,ndy,ndz,zne,nb1,nb2,mcycl,eps,info,occ)
      use util
      implicit none
      integer ndx,ndy,ndz,nb1,nb2
      integer info
      double precision occ
      real*8 emesh1(  -ndx:ndx,    -ndy:ndy,  0:ndz  ,nb1:nb2)
      real*8 emesh2(-ndx*2:ndx*2,-ndy*2:ndy*2,0:ndz*2,nb1:nb2)
      real*8 ef
      real*8 zne
      integer mcycl
      real*8 eps

      real*8 etmp(:),emx1(:,:),emx2(:,:),tmx(:)
      logical:: lb(:)
      integer:: tid(:)
      allocatable etmp,emx1,emx2,tmx,lb,tid
      integer ierr

      integer nxy6, nxy60, icycl, ib
      real*8 ef1,ef2
      real*8 s, s1, s2, ss, d
C
C nxy6 = 4*ndx*ndy is the total number of the cell in a layer
C This number is not huge today.
C
      nxy6=4*ndx*ndy
      nxy60=16*ndx*ndy
C
C     nxy60 > nxy6
C
      allocate(etmp(nxy60*12),lb(nxy60),
     &     emx1(2,nb1:nb2),emx2(2,nb1:nb2),stat=ierr)
      call chkalloc('fermi','etmp',ierr)
      do ib=nb1,nb2
        call emeshmmx((2*ndx+1)*(2*ndy+1)*(ndz+1),
     &       emesh1(-ndx,-ndy,0,ib),emx1(1,ib))
        call emeshmmx((4*ndx+1)*(4*ndy+1)*(2*ndz+1),
     &       emesh2(-ndx*2,-ndy*2,0,ib),emx2(1,ib))
      end do

      allocate(tmx(nb1:nb2),tid(nb1:nb2),stat=ierr)
      call chkalloc('fermi','tmp',ierr)

      tmx = emx2(1,:)
      call hsort(nb2-nb1+1,tmx,tid)
      ib = floor(zne)-1
      ib = min(ib,nb2-nb1+1)
      ib = max(ib,1)+nb1-1
      ef1 = tmx(ib)

      tmx = emx2(2,:)
      call hsort(nb2-nb1+1,tmx,tid)
      ib = ceiling(zne)+1
      ib = min(ib,nb2-nb1+1)
      ib = max(ib,1)+nb1-1
      ef2 = tmx(ib)

      deallocate(tmx,tid)
C
      icycl=0
 1000 continue
      icycl=icycl+1
      if(icycl.gt.mcycl) go to 900
      ef=(ef1+ef2)*0.5d0
      s=0.0d0
      do ib=nb1,nb2
        s1=0.0d0
        s2=0.0d0
        if (ef.le.emx1(1,ib)) then
          s1=0.0d0
        else if (ef.lt.emx1(2,ib)) then
          call fergen(emesh1(-ndx  ,  -ndy,0,ib),etmp(1),lb,s1,ef
     &         ,ndx,ndy,ndz,nxy6)
        else
          s1=1.0d0
        end if
        if (ef.le.emx2(1,ib)) then
          s2=0.0d0
        else if (ef.lt.emx2(2,ib)) then
          call fergen(emesh2(-ndx*2,-ndy*2,0,ib),etmp(1),lb,s2,ef
     &         ,ndx*2,ndy*2,ndz*2,nxy60)
        else
          s2=1.0d0
        end if
        ss=(4.0d0*s2-s1)/3.0d0
        s=s+ss
      end do
      d=abs(s-zne)
      if(d.le.eps) go to 2000
      if(s.gt.zne) then
        ef2=ef
      else
        ef1=ef
      end if
      go to 1000
 2000 continue
C      
C EF CONVERGED
      info = 0
      occ = s
      deallocate(etmp,lb,emx1,emx2)
      return
C
  900 continue
C
C EF IS NOT CONVERGED
      deallocate(etmp,lb,emx1,emx2)
      info = 1
      return
      contains
      subroutine emeshmmx(n,emesh,emx)
      implicit none
      integer:: n
      real(kind=8):: emesh(n),emx(2)
      integer:: i
      emx(1) = emesh(1)
      emx(2) = emesh(1)
      do i=2,n
        emx(1) = min(emx(1),emesh(i))
        emx(2) = max(emx(2),emesh(i))
      end do
      return
      end subroutine emeshmmx
      end subroutine fermi
C*********************************************************************
      subroutine fergen(emesh,e,lb,s,ef,ndx,ndy,ndz,nxy6)
#ifdef NEW_TETRAHEDRON
      use subr_tetra
#endif
      implicit none
      integer ndx,ndy,ndz,nxy6
      double precision emesh, e,s,ef
      dimension emesh(-ndx:ndx,-ndy:ndy,0:ndz)
      dimension e(nxy6,12)
      logical lb(nxy6)
      double precision a1,a2,a3
      integer ix,iy,iz,nis
#ifdef NEW_TETRAHEDRON
      double precision ss
#endif

      do 20 iz=0,ndz-1
      nis=0
      do 30 iy=-ndy,ndy-1
      do 30 ix=-ndx,ndx-1
C
      a1=max(emesh(ix,iy  ,iz  ),emesh(ix+1,iy  ,iz  ))
      a2=max(emesh(ix,iy+1,iz  ),emesh(ix+1,iy+1,iz  ))
      a1=max(a1,a2)
      a2=max(emesh(ix,iy  ,iz+1),emesh(ix+1,iy  ,iz+1))
      a1=max(a1,a2)
      a2=max(emesh(ix,iy+1,iz+1),emesh(ix+1,iy+1,iz+1))
      a1=max(a1,a2)
C
      a2=min(emesh(ix,iy  ,iz  ),emesh(ix+1,iy  ,iz  ))
      a3=min(emesh(ix,iy+1,iz  ),emesh(ix+1,iy+1,iz  ))
      a2=min(a2,a3)
      a3=min(emesh(ix,iy  ,iz+1),emesh(ix+1,iy  ,iz+1))
      a2=min(a2,a3)
      a3=min(emesh(ix,iy+1,iz+1),emesh(ix+1,iy+1,iz+1))
      a2=min(a2,a3)
C
      if(ef.gt.a2.and.ef.lt.a1) then
      nis=nis+1
      e(nis,1)=emesh(ix  ,iy  ,iz  )
      e(nis,2)=emesh(ix  ,iy+1,iz  )
      e(nis,3)=emesh(ix  ,iy  ,iz+1)
      e(nis,4)=emesh(ix  ,iy+1,iz+1)
      e(nis,5)=emesh(ix+1,iy  ,iz  )
      e(nis,6)=emesh(ix+1,iy+1,iz  )
      e(nis,7)=emesh(ix+1,iy  ,iz+1)
      e(nis,8)=emesh(ix+1,iy+1,iz+1)
      else
      if(ef.ge.a1) then
      s=s+2.0d0
      end if
      end if
   30 continue
      if(nis.gt.nxy6) go to 900
      if(nis.eq.0) go to 20
#ifdef NEW_TETRAHEDRON
      call tetra0c(e(1,1),e(1,2),e(1,3),e(1,4)
     &           ,e(1,5),e(1,6),e(1,7),e(1,8),ef,ss,nis,0)
c     
c     consider the spin degeneracy
c
      s = s + 2.0d0*ss
#else
      call efintp(e(1,1),e(1,2),e(1,3),e(1,4)
     &           ,e(1,5),e(1,6),e(1,7),e(1,8)
     &           ,e(1,9),e(1,10),e(1,11),e(1,12),lb,ef,s,nis)
#endif
   20 continue
      s=s/dble(8*ndx*ndy*ndz)
      return
  900 continue
      write(6,*) 'NXY6 IS TOO SMALL'
      stop
      end
C*********************************************************************
#ifndef NEW_TETRAHEDRON
      subroutine efintp(e1,e2,e3,e4,e5,e6,e7,e8
     &                 ,ee1,ee2,ee3,ee4,lb,ef,s,nis)
      implicit real*8(a-h,o-z)
      dimension e1(nis),e2(nis),e3(nis),e4(nis)
      dimension e5(nis),e6(nis),e7(nis),e8(nis)
      dimension ee1(nis),ee2(nis),ee3(nis),ee4(nis)
      logical lb(nis)
      call tetra3(e1,e2,e3,e5,ee1,ee2,ee3,ee4,lb,ef,s,nis)
      call tetra3(e2,e3,e5,e7,ee1,ee2,ee3,ee4,lb,ef,s,nis)
      call tetra3(e2,e5,e6,e7,ee1,ee2,ee3,ee4,lb,ef,s,nis)
      call tetra3(e4,e3,e2,e8,ee1,ee2,ee3,ee4,lb,ef,s,nis)
      call tetra3(e3,e2,e8,e6,ee1,ee2,ee3,ee4,lb,ef,s,nis)
      call tetra3(e3,e8,e7,e6,ee1,ee2,ee3,ee4,lb,ef,s,nis)
      return
      end
C*********************************************************************
      subroutine tetra3(e1,e2,e3,e4,ee1,ee2,ee3,ee4,lb,ef,s,nis)
      implicit real*8(a-h,o-z)
      dimension e1(nis),e2(nis),e3(nis),e4(nis)
      dimension ee1(nis),ee2(nis),ee3(nis),ee4(nis)
      logical lb(nis)
      do 10 i=1,nis
      a     =max(e1(i) ,e2(i) )
      ee2(i)=max(e3(i) ,e4(i) )
      ee3(i)=min(e1(i) ,e2(i) )
      b     =min(e3(i) ,e4(i) )
      ee1(i)=max(a     ,ee2(i))
      a     =min(a     ,ee2(i))
      ee4(i)=min(ee3(i),b     )
      b     =max(ee3(i),b     )
      ee2(i)=max(a     ,b     )
      ee3(i)=min(a     ,b     )
   10 continue
      call tetra4(ee1,ee2,ee3,ee4,lb,s,ef,nis)
      return
      end
C*********************************************************************
      subroutine tetra4(e1,e2,e3,e4,lb,s,ef,nis)
      implicit real*8(a-h,o-z)
      dimension e1(nis),e2(nis),e3(nis),e4(nis)
      logical lb(nis)
      data third/0.333333333333333333333333333d0/
C
      do 10 in=1,nis
      if((e1(in).eq.e2(in)).and.(ef.eq.e2(in))) then
      lb(in)=.true.
      else
      lb(in)=.false.
      end if
   10 continue
C
      do 20 in=1,nis
      if(ef.ge.e1(in)) then
      s=s+third
      end if
   20 continue
C
      do 30 in=1,nis
      if((ef.gt.e2(in)).and.(ef.lt.e1(in))) then
      s=s+third
     & -third*(e1(in)-ef)*(e1(in)-ef)*(e1(in)-ef)
     & /(e1(in)-e4(in))/(e1(in)-e3(in))/(e1(in)-e2(in))
      end if
   30 continue
C
      do 40 in=1,nis
      if((ef.ge.e3(in)).and.(ef.le.e2(in)).and.(e2(in).ne.e3(in)).and.
     &   (.not.lb(in))) then
      s=s+((ef-e1(in))*(ef-e4(in))*(ef-e4(in))
     & /(e3(in)-e1(in))/(e2(in)-e4(in))/(e1(in)-e4(in))
     & +(ef-e4(in))*(e2(in)-ef)*(ef-e3(in))
     & /(e2(in)-e4(in))/(e2(in)-e3(in))/(e1(in)-e3(in))
     & +(ef-e3(in))*(ef-e3(in))/(e1(in)-e3(in))/(e2(in)-e3(in)))
     & *third
      end if
   40 continue
C
      do 50 in=1,nis
      if((ef.eq.e3(in)).and.(e3(in).eq.e2(in)).and.(.not.lb(in))) then
      s=s+third*(e3(in)-e4(in))/(e1(in)-e4(in))
      end if
   50 continue
C
      do 60 in=1,nis
      if((ef.gt.e4(in)).and.(ef.lt.e3(in))) then
      s=s-(e4(in)-ef)*(e4(in)-ef)*(e4(in)-ef)
     & /(e1(in)-e4(in))/(e2(in)-e4(in))/(e3(in)-e4(in))
     & *third
      end if
   60 continue
C
      return
      end
#endif
C*********************************************************************
      subroutine romb(pe,vp1,vp2,nkr,nb1,nb2)
      implicit none
      integer nkr,nb1,nb2
      double precision pe(nkr,nb1:nb2)
      double precision vp1(nkr,nb1:nb2),vp2(nkr,nb1:nb2)

      integer ib,k

      do ib=nb1,nb2
        do k=1,nkr
          pe(k,ib)=(vp2(k,ib)*4.0d0-vp1(k,ib))/3.0d0
        end do
      end do
      return
      end
C**********************************************************************
      subroutine vinteg(emesh,kj,vp
     &                 ,ef,ndx,ndy,ndz,nkr,nb1,nb2)
      implicit none
      integer ndx,ndy,ndz,nkr,nb1,nb2
      integer kj(3,nkr)
      real(kind=8) emesh(-ndx:ndx,-ndy:ndy,0:ndz,nb1:nb2),ef
      real*8 vp(nkr,nb1:nb2)
C
      integer kint(:),knx(:,:),lnx(:,:)
      real*8 vmesh(:,:,:,:),dmesh(:,:,:,:)
      integer ierr
      allocatable kint,knx,lnx,vmesh,dmesh
C
      integer nxy6
      real(kind=8) adx,ady,adz,wk
      integer k,ib,iz,lmod,kmod
C
      real(kind=8),parameter::  p2 = 6.28318530717958648d0
C
      nxy6=4*ndx*ndy
      allocate(kint(nkr),lnx(2,nxy6),knx(2,(2*ndx+1)*(2*ndy+1)),
     &     vmesh(-ndx:ndx,-ndy:ndy,nkr,2),
     &     dmesh(-ndx:ndx,-ndy:ndy,nkr,2),stat=ierr)
      call chkalloc('vinteg','temp',ierr)
C
      adx=1.0d0/dble(ndx*2)*p2
      ady=1.0d0/dble(ndy*2)*p2
      adz=1.0d0/dble(ndz*2)*p2
C
      do 1000 k=1,nkr
      call kingen(kj(1,k),kint(k))
 1000 continue
C
      do 2000 ib=nb1,nb2
      do 2000 k=1,nkr
      vp(k,ib)=0.0d0
 2000 continue
C
      do 10 iz=0,ndz-1
      lmod=mod(iz,2)+1
      kmod=lmod+1
      if(iz.eq.0) kmod=1
      go to (1,2,3),kmod
C
    1 call vdef(vmesh(-ndx,-ndy,1,1),dmesh(-ndx,-ndy,1,1),kj
     &         ,iz,ndx,ndy,nkr,adx,ady,adz)
      call vdef(vmesh(-ndx,-ndy,1,2),dmesh(-ndx,-ndy,1,2),kj
     &         ,iz+1,ndx,ndy,nkr,adx,ady,adz)
      go to 100
    2 call vdef(vmesh(-ndx,-ndy,1,2),dmesh(-ndx,-ndy,1,2),kj
     &         ,iz+1,ndx,ndy,nkr,adx,ady,adz)
      go to 100
    3 call vdef(vmesh(-ndx,-ndy,1,1),dmesh(-ndx,-ndy,1,1),kj
     &         ,iz+1,ndx,ndy,nkr,adx,ady,adz)
  100 continue
      do ib=nb1,nb2
        if (lmod.eq.1) then
          call integ(emesh(-ndx,-ndy,iz,ib),emesh(-ndx,-ndy,iz+1,ib)
     &         ,vmesh(-ndx,-ndy,1,1),vmesh(-ndx,-ndy,1,2)
     &         ,dmesh(-ndx,-ndy,1,1),dmesh(-ndx,-ndy,1,2)
     &         ,knx,lnx,kj,kint,ef,vp
     &         ,nb1,nb2,nkr,ndx,ndy,ndz,nxy6,ib)
        else if (lmod.eq.2) then
          call integ(emesh(-ndx,-ndy,iz,ib),emesh(-ndx,-ndy,iz+1,ib)
     &         ,vmesh(-ndx,-ndy,1,2),vmesh(-ndx,-ndy,1,1)
     &         ,dmesh(-ndx,-ndy,1,2),dmesh(-ndx,-ndy,1,1)
     &         ,knx,lnx,kj,kint,ef,vp
     &         ,nb1,nb2,nkr,ndx,ndy,ndz,nxy6,ib)
        else
          write(6,*) 'vinteg: invalid lmod'
          stop
        end if
      end do
   10 continue
C
      wk=1.0d0/dble(8*ndx*ndy*ndz)
      do 50 ib=nb1,nb2
      do 50 k=1,nkr
      vp(k,ib)=vp(k,ib)*wk
   50 continue
C
      deallocate(kint,knx,lnx,vmesh,dmesh)
      return
      end
C*********************************************************************
      subroutine kingen(kj,kint)
      implicit integer(a-z)
      dimension kj(3)
      if(kj(3).eq.0) then
      iz=0
      else
      iz=1
      end if
      if(kj(2).eq.0) then
      iy=0
      else
      iy=1
      end if
      if(kj(1).eq.0) then
      ix=0
      else
      ix=1
      end if
      kint=iz+2*iy+4*ix+1
      return
      end
C**********************************************************************
      subroutine vdef(vmesh,dmesh,kj,iz,ndx,ndy,nkr,adx,ady,adz)
      implicit none
      integer ndx,ndy,nkr,iz
      double precision adx,ady,adz
      double precision vmesh(-ndx:ndx,-ndy:ndy,nkr)
      double precision dmesh(-ndx:ndx,-ndy:ndy,nkr)
      integer kj(3,nkr)
      integer k,ix,iy
      double precision x,y,z,xx,yy
C
!$omp parallel do private(k,x,y,z,xx,yy,ix,iy)
      do k=1,nkr
         z=adz*iz*kj(3,k)
         xx=adx*kj(1,k)
         yy=ady*kj(2,k)
         do ix=-ndx,ndx
            x=xx*ix+z
            do iy=-ndy,ndy
               y=yy*iy+x
               vmesh(ix,iy,k)=cos(y)
               dmesh(ix,iy,k)=sin(y)
            end do
         end do
      end do
C
      return
      end
C********************************************************************
      subroutine integ(emesh1,emesh2,vmesh1,vmesh2,dmesh1,dmesh2
     &                ,knx,lnx,kj,kint,ef,vp
     &                ,nb1,nb2,nkr,ndx,ndy,ndz,nxy6,ib)
      implicit none
      integer nb1,nb2,nkr,ndx,ndy,ndz,nxy6,ib
      real(kind=8) ef,vp(nkr,nb1:nb2)
      real(kind=8) emesh1(-ndx:ndx,-ndy:ndy)
      real(kind=8) emesh2(-ndx:ndx,-ndy:ndy)
      real(kind=8) vmesh1(-ndx:ndx,-ndy:ndy,nkr)
      real(kind=8) vmesh2(-ndx:ndx,-ndy:ndy,nkr)
      real(kind=8) dmesh1(-ndx:ndx,-ndy:ndy,nkr)
      real(kind=8) dmesh2(-ndx:ndx,-ndy:ndy,nkr)
      integer kj(3,nkr),lnx(2,nxy6),kint(nkr)
      integer knx(2,(2*ndx+1)*(2*ndy+1))
      real(kind=8),parameter:: pai = 3.14159265358979324d0
      integer nis,ix,iy,is,k,kis
      real(kind=8):: a1,a2,a3,f1,f2,f3
C
      nis=0
      kis=0
      do ix=-ndx,ndx-1
        do iy=-ndy,ndy-1
          a1=max(emesh1(ix,iy  ),emesh1(ix+1,iy  ))
          a2=max(emesh1(ix,iy+1),emesh1(ix+1,iy+1))
          a1=max(a1,a2)
          a2=max(emesh2(ix,iy  ),emesh2(ix+1,iy  ))
          a1=max(a1,a2)
          a2=max(emesh2(ix,iy+1),emesh2(ix+1,iy+1))
          a1=max(a1,a2)
          a2=min(emesh1(ix,iy  ),emesh1(ix+1,iy  ))
          a3=min(emesh1(ix,iy+1),emesh1(ix+1,iy+1))
          a2=min(a2,a3)
          a3=min(emesh2(ix,iy  ),emesh2(ix+1,iy  ))
          a2=min(a2,a3)
          a3=min(emesh2(ix,iy+1),emesh2(ix+1,iy+1))
          a2=min(a2,a3)
          if(ef.lt.a1.and.ef.gt.a2) then
            nis=nis+1
            lnx(1,nis)=ix
            lnx(2,nis)=iy
          else if (ef.ge.a1) then
            kis=kis+1
            knx(1,kis)=ix
            knx(2,kis)=iy
          end if
        end do
      end do
!$omp parallel do private(k,is,ix,iy,f1,f2,f3)
      do k=1,nkr
         select case (kint(k))
         case (1)
            do is=1,kis
               ix=knx(1,is)
               iy=knx(2,is)
               vp(k,ib)=vp(k,ib)+2.0d0
            end do
         case (2)
            f3=dble(ndz)/pai/dble(kj(3,k))
            do is=1,kis
               ix=knx(1,is)
               iy=knx(2,is)
               vp(k,ib)=vp(k,ib)+2.0d0*f3*
     &              (dmesh2(ix,iy,k)-dmesh1(ix,iy,k))
            end do
         case (3)
            f2=dble(ndy)/pai/dble(kj(2,k))
            do is=1,kis
               ix=knx(1,is)
               iy=knx(2,is)
               vp(k,ib)=vp(k,ib)+2.0d0*f2*
     &              (dmesh1(ix,iy+1,k)-dmesh1(ix,iy,k))
            end do
         case (4)
            f2=dble(ndy)/pai/dble(kj(2,k))
            f3=dble(ndz)/pai/dble(kj(3,k))
            do is=1,kis
               ix=knx(1,is)
               iy=knx(2,is)
               vp(k,ib)=vp(k,ib)+2.0d0*f2*f3
     &              *(vmesh2(ix,iy,k)-vmesh1(ix,iy,k)
     &              +vmesh1(ix,iy+1,k)-vmesh2(ix,iy+1,k))
            end do
         case (5)
            f1=dble(ndx)/pai/dble(kj(1,k))
            do is=1,kis
               ix=knx(1,is)
               iy=knx(2,is)
               vp(k,ib)=vp(k,ib)+2.0d0*f1*
     &              (dmesh1(ix+1,iy,k)-dmesh1(ix,iy,k))
            end do
         case (6)
            f1=dble(ndx)/pai/dble(kj(1,k))
            f3=dble(ndz)/pai/dble(kj(3,k))
            do is=1,kis
               ix=knx(1,is)
               iy=knx(2,is)
               vp(k,ib)=vp(k,ib)+2.0d0*f1*f3
     &              *(vmesh2(ix,iy,k)-vmesh1(ix,iy,k)
     &              +vmesh1(ix+1,iy,k)-vmesh2(ix+1,iy,k))
            end do
         case(7)
            f1=dble(ndx)/pai/dble(kj(1,k))
            f2=dble(ndy)/pai/dble(kj(2,k))
            do is=1,kis
               ix=knx(1,is)
               iy=knx(2,is)
               vp(k,ib)=vp(k,ib)+2.0d0*f1*f2
     &              *(vmesh1(ix,iy+1,k)-vmesh1(ix,iy,k)
     &              +vmesh1(ix+1,iy,k)-vmesh1(ix+1,iy+1,k))
            end do
         case(8)
            f1=dble(ndx)/pai/dble(kj(1,k))
            f2=dble(ndy)/pai/dble(kj(2,k))
            f3=dble(ndz)/pai/dble(kj(3,k))
            do is=1,kis
               ix=knx(1,is)
               iy=knx(2,is)
               vp(k,ib)=vp(k,ib)+2.0d0*f1*f2*f3
     &              *(dmesh1(ix,iy,k)-dmesh2(ix,iy,k)
     &              -dmesh1(ix,iy+1,k)+dmesh2(ix,iy+1,k)
     &              -dmesh1(ix+1,iy,k)+dmesh2(ix+1,iy,k)
     &              +dmesh1(ix+1,iy+1,k)-dmesh2(ix+1,iy+1,k))
            end do
         end select
      end do
C
      if (nis.eq.0) then
        return
      end if
      call integp(emesh1,emesh2,vmesh1,vmesh2,lnx
     &           ,ef,vp(1,ib),ndx,ndy,nkr,nis)
C
      return
      end
C**********************************************************************
      subroutine integp(emesh1,emesh2,vmesh1,vmesh2,lnx
     &           ,ef,vp,ndx,ndy,nkr,nis)
#ifdef NEW_TETRAHEDRON
      use subr_tetra
#endif
      implicit none
      integer lnx,ndx,ndy,nkr,nis
      double precision emesh1,emesh2,vmesh1,vmesh2,ef,vp
      dimension emesh1(-ndx:ndx,-ndy:ndy),emesh2(-ndx:ndx,-ndy:ndy)
      dimension vmesh1(-ndx:ndx,-ndy:ndy,nkr)
      dimension vmesh2(-ndx:ndx,-ndy:ndy,nkr)
      dimension lnx(2,nis),vp(nkr)

      double precision e(nis,8),v(nis,8)
#ifndef NEW_TETRAHEDRON
      double precision ee(nis,4),vv(nis,4)
      logical lb(nis)
#endif

      integer ierr
C
      integer is,ix,iy,k
      double precision s
C
c      write(6,*) '******* NIS ******',nis
      do is=1,nis
         ix=lnx(1,is)
         iy=lnx(2,is)
         e(is,1)=emesh1(ix  ,iy  )
         e(is,2)=emesh1(ix  ,iy+1)
         e(is,3)=emesh2(ix  ,iy  )
         e(is,4)=emesh2(ix  ,iy+1)
         e(is,5)=emesh1(ix+1,iy  )
         e(is,6)=emesh1(ix+1,iy+1)
         e(is,7)=emesh2(ix+1,iy  )
         e(is,8)=emesh2(ix+1,iy+1)
      end do
C
#ifdef NEW_TETRAHEDRON
!$omp parallel do private(v,k,is,ix,iy,s)
#else
!$omp parallel do private(ee,v,vv,lb,k,is,ix,iy,s)
#endif
      do k=1,nkr
         do is=1,nis
            ix=lnx(1,is)
            iy=lnx(2,is)
            v(is,1)=vmesh1(ix  ,iy  ,k)
            v(is,2)=vmesh1(ix  ,iy+1,k)
            v(is,3)=vmesh2(ix  ,iy  ,k)
            v(is,4)=vmesh2(ix  ,iy+1,k)
            v(is,5)=vmesh1(ix+1,iy  ,k)
            v(is,6)=vmesh1(ix+1,iy+1,k)
            v(is,7)=vmesh2(ix+1,iy  ,k)
            v(is,8)=vmesh2(ix+1,iy+1,k)
         end do
#ifdef NEW_TETRAHEDRON
         call tetra0(e(1,1),e(1,2),e(1,3),e(1,4)
     &        ,e(1,5),e(1,6),e(1,7),e(1,8)
     &        ,v(1,1),v(1,2),v(1,3),v(1,4)
     &        ,v(1,5),v(1,6),v(1,7),v(1,8)
     &        ,ef,s,nis,0)
         !
         ! consider the spin degeneracy
         !
         s=2.0d0*s
#else
         s=0.0d0
         call tetra0(e(1,1),e(1,2),e(1,3),e(1,4)
     &        ,e(1,5),e(1,6),e(1,7),e(1,8)
     &        ,v(1,1),v(1,2),v(1,3),v(1,4)
     &        ,v(1,5),v(1,6),v(1,7),v(1,8)
     &        ,ee(1,1),ee(1,2),ee(1,3),ee(1,4)
     &        ,vv(1,1),vv(1,2),vv(1,3),vv(1,4)
     &        ,lb,ef,s,nis)
#endif
         vp(k)=vp(k)+s
      end do
      return
      end

#ifndef NEW_TETRAHEDRON
C******************************************************************
      subroutine tetra0(e1,e2,e3,e4,e5,e6,e7,e8
     &                 ,v1,v2,v3,v4,v5,v6,v7,v8
     &                 ,ee1,ee2,ee3,ee4,vv1,vv2,vv3,vv4
     &                 ,lb,ef,s,nis)
      implicit real*8(a-h,o-z)
      dimension e1(nis),e2(nis),e3(nis),e4(nis),e5(nis),e6(nis)
     &         ,e7(nis),e8(nis)
      dimension v1(nis),v2(nis),v3(nis),v4(nis),v5(nis),v6(nis)
     &         ,v7(nis),v8(nis)
      dimension ee1(nis),ee2(nis),ee3(nis),ee4(nis)
      dimension vv1(nis),vv2(nis),vv3(nis),vv4(nis)
      logical lb(nis)
      call tetra1(e1,e2,e3,e5,v1,v2,v3,v5
     &           ,ee1,ee2,ee3,ee4,vv1,vv2,vv3,vv4,lb,ef,s,nis)
      call tetra1(e2,e3,e5,e7,v2,v3,v5,v7
     &           ,ee1,ee2,ee3,ee4,vv1,vv2,vv3,vv4,lb,ef,s,nis)
      call tetra1(e2,e5,e6,e7,v2,v5,v6,v7
     &           ,ee1,ee2,ee3,ee4,vv1,vv2,vv3,vv4,lb,ef,s,nis)
      call tetra1(e4,e3,e2,e8,v4,v3,v2,v8
     &           ,ee1,ee2,ee3,ee4,vv1,vv2,vv3,vv4,lb,ef,s,nis)
      call tetra1(e3,e2,e8,e6,v3,v2,v8,v6
     &           ,ee1,ee2,ee3,ee4,vv1,vv2,vv3,vv4,lb,ef,s,nis)
      call tetra1(e3,e8,e7,e6,v3,v8,v7,v6
     &           ,ee1,ee2,ee3,ee4,vv1,vv2,vv3,vv4,lb,ef,s,nis)
      return
      end
C*********************************************************************
      subroutine tetra1(e1,e2,e3,e4,v1,v2,v3,v4
     &                 ,ee1,ee2,ee3,ee4,vv1,vv2,vv3,vv4,lb,ef,s,nis)
      implicit real*8(a-h,o-z)
      dimension e1(nis),e2(nis),e3(nis),e4(nis)
      dimension v1(nis),v2(nis),v3(nis),v4(nis)
      dimension ee1(nis),ee2(nis),ee3(nis),ee4(nis)
      dimension vv1(nis),vv2(nis),vv3(nis),vv4(nis)
      logical lb(nis)
C
      do 10 in=1,nis
      if(e1(in).ge.e2(in)) then
      a1=e1(in)
      b1=v1(in)
      a2=e2(in)
      b2=v2(in)
      else
      a1=e2(in)
      b1=v2(in)
      a2=e1(in)
      b2=v1(in)
      end if
C
      if(e3(in).ge.e4(in)) then
      c1=e3(in)
      d1=v3(in)
      c2=e4(in)
      d2=v4(in)
      else
      c1=e4(in)
      d1=v4(in)
      c2=e3(in)
      d2=v3(in)
      end if
C
      if(a1.ge.c1) then
      ee1(in)=a1
      vv1(in)=b1
      a1=c1
      b1=d1
      else
      ee1(in)=c1
      vv1(in)=d1
      end if
C
      if(a2.ge.c2) then
      ee4(in)=c2
      vv4(in)=d2
      else
      ee4(in)=a2
      vv4(in)=b2
      a2=c2
      b2=d2
      end if
C
      if(a1.ge.a2) then
      ee2(in)=a1
      vv2(in)=b1
      ee3(in)=a2
      vv3(in)=b2
      else
      ee2(in)=a2
      vv2(in)=b2
      ee3(in)=a1
      vv3(in)=b1
      end if
C
   10 continue
C
      call tetra2(ee1,ee2,ee3,ee4,vv1,vv2,vv3,vv4,lb,ef,s,nis)
      return
      end
C*********************************************************************
      subroutine tetra2(e1,e2,e3,e4,v1,v2,v3,v4,lb,ef,s,nis)
      implicit real*8(a-h,o-z)
      dimension e1(nis),e2(nis),e3(nis),e4(nis)
      dimension v1(nis),v2(nis),v3(nis),v4(nis)
      dimension lb(nis)
      logical lb
      data unit/0.083333333333333333333333333d0/
C
      do 10 in=1,nis
      if((e1(in).eq.e2(in)).and.(ef.eq.e2(in))) then
      lb(in)=.true.
      else
      lb(in)=.false.
      end if
   10 continue
C
      do 20 in=1,nis
      if(ef.ge.e1(in)) then
      s=s+(v1(in)+v2(in)+v3(in)+v4(in))*unit
      end if
   20 continue
C
      do 30 in=1,nis
      if((ef.gt.e2(in)).and.(ef.lt.e1(in))) then
      s=s+(v1(in)+v2(in)+v3(in)+v4(in))*unit
     & -unit*(e1(in)-ef)*(e1(in)-ef)*(e1(in)-ef)
     & /(e1(in)-e4(in))/(e1(in)-e3(in))/(e1(in)-e2(in))
     & *(4.0d0*v1(in)+(ef-e1(in))*((v4(in)-v1(in))/(e4(in)-e1(in))
     & +(v3(in)-v1(in))/(e3(in)-e1(in))
     & +(v2(in)-v1(in))/(e2(in)-e1(in))))
      end if
   30 continue
C
      do 40 in=1,nis
      if((ef.ge.e3(in)).and.(ef.le.e2(in)).and.(e2(in).ne.e3(in)).and.
     &   (.not.lb(in))) then
      s=s+unit*((ef-e1(in))*(ef-e4(in))*(ef-e4(in))
     & /(e3(in)-e1(in))/(e2(in)-e4(in))/(e1(in)-e4(in))
     & *(3.0d0*v4(in)+(ef-e4(in))*(v2(in)-v4(in))/(e2(in)-e4(in))
     &        +v3(in)+(ef-e4(in))*(v1(in)-v4(in))/(e1(in)-e4(in))
     &               +(ef-e3(in))*(v1(in)-v3(in))/(e1(in)-e3(in)))
     & +(ef-e4(in))*(e2(in)-ef)*(ef-e3(in))
     & /(e2(in)-e4(in))/(e2(in)-e3(in))/(e1(in)-e3(in))
     & *(2.0d0*v4(in)+(ef-e4(in))*(v2(in)-v4(in))/(e2(in)-e4(in))
     &  +2.0d0*v3(in)+(ef-e3(in))*(v2(in)-v3(in))/(e2(in)-e3(in))
     &               +(ef-e3(in))*(v1(in)-v3(in))/(e1(in)-e3(in)))
     & +(ef-e3(in))*(ef-e3(in))/(e1(in)-e3(in))/(e2(in)-e3(in))
     & *(3.0d0*v3(in)+(ef-e3(in))*(v2(in)-v3(in))/(e2(in)-e3(in))
     &        +v4(in)+(ef-e3(in))*(v1(in)-v3(in))/(e1(in)-e3(in))))
      end if
   40 continue
C
      do 50 in=1,nis
      if((ef.eq.e3(in)).and.(e3(in).eq.e2(in)).and.(.not.lb(in))) then
      s=s+unit*(e3(in)-e4(in))/(e1(in)-e4(in))
     & *(v2(in)+(e3(in)-e4(in))*(v1(in)-v4(in))/(e1(in)-e4(in))
     &   +v3(in)+2.0d0*v4(in))
      end if
   50 continue
C
      do 60 in=1,nis
      if((ef.gt.e4(in)).and.(ef.lt.e3(in))) then
      s=s-unit*(e4(in)-ef)*(e4(in)-ef)*(e4(in)-ef)
     & /(e1(in)-e4(in))/(e2(in)-e4(in))/(e3(in)-e4(in))
     & *(4.0d0*v4(in)+(ef-e4(in))*((v3(in)-v4(in))/(e3(in)-e4(in))
     & +(v1(in)-v4(in))/(e1(in)-e4(in))
     & +(v2(in)-v4(in))/(e2(in)-e4(in))))
      end if
   60 continue
C
      return
      end
#endif
