!
! Copyright (c) 2000-2013 Yoshihide Yoshimoto
!
module symwfn
contains
  subroutine irrdrg(sk,ng,rg,ngir,irrg)
    implicit none
    real(kind=8),intent(in):: sk(3)
    integer,intent(in):: ng
    integer,intent(in):: rg(3,3,ng)
    integer:: ngir,irrg(2*ng)

    real(kind=8),parameter:: eps = 1.0d-8

    integer:: ig,jg
    real(kind=8):: vtmp(3),tsk(3,ng),tski(3,ng),d
    logical:: done(ng,2)

    do ig=1,ng
       vtmp = matmul(rg(:,:,ig),sk)

       tsk(1,ig) = modulo(vtmp(1),1.0d0)
       tsk(2,ig) = modulo(vtmp(2),1.0d0)
       tsk(3,ig) = modulo(vtmp(3),1.0d0)

       tski(1,ig) = modulo(-vtmp(1),1.0d0)
       tski(2,ig) = modulo(-vtmp(2),1.0d0)
       tski(3,ig) = modulo(-vtmp(3),1.0d0)
    end do
    ngir = 0
    done = .false.
    do ig=1,ng
       if (.not. done(ig,1)) then
          done(ig,1) = .true.
          ngir = ngir + 1
          irrg(ngir) = ig

          do jg=ig+1,ng
             d = abs(tsk(1,ig)-tsk(1,jg)) + abs(tsk(2,ig)-tsk(2,jg)) &
                  + abs(tsk(3,ig)-tsk(3,jg))
             if (d.lt.eps) done(jg,1) = .true.
          end do
          do jg=ig,ng
             d = abs(tsk(1,ig)-tski(1,jg)) + abs(tsk(2,ig)-tski(2,jg)) &
                  + abs(tsk(3,ig)-tski(3,jg))
             if (d.lt.eps) done(jg,2) = .true.
          end do
       end if
       if (.not. done(ig,2)) then
          done(ig,2) = .true.
          ngir = ngir + 1
          irrg(ngir) = -ig

          do jg=ig+1,ng
             d = abs(tski(1,ig)-tsk(1,jg)) + abs(tski(2,ig)-tsk(2,jg)) &
                  + abs(tski(3,ig)-tsk(3,jg))
             if (d.lt.eps) done(jg,1) = .true.

             d = abs(tski(1,ig)-tski(1,jg)) + abs(tski(2,ig)-tski(2,jg)) &
                  + abs(tski(3,ig)-tski(3,jg))
             if (d.lt.eps) done(jg,2) = .true.
          end do
       end if
    end do

    return
  end subroutine irrdrg

  subroutine transskkg(sk,nkm,kg,rg,srg,trssk,trskg)
    implicit none
    real(kind=8),intent(in):: sk(3)
    integer,intent(in):: nkm,kg(3,nkm),rg(3,3),srg
    real(kind=8),intent(out):: trssk(3)
    integer,intent(out):: trskg(3,nkm)

    integer:: ig

    trssk = sk
    trssk = srg*matmul(rg,trssk)

    do ig=1,nkm
       trskg(:,ig) = srg*matmul(rg,kg(:,ig))
    end do

    return
  end subroutine transskkg

end module symwfn
