!
! Copyright (c) 2000-2013 Yoshihide Yoshimoto
!
program test
  use b3lyp_xcgga
  use xc_f90_types_m
  use xc_f90_lib_m
  implicit none
  integer,parameter:: np = 8000
  real(kind=8):: pn(np,2),pdn(np,2),pfxcn(np,2),pfxcdn(np,2),fxcdn(np)
  real(kind=8):: pfxcnx(np,2),pfxcdnx(np,2),fxcdnx(np)
  real(kind=8):: apdn(np,2),adn(np)
  real(kind=8):: exc(np),excx(np),excsp,excspx
  real(kind=8):: x,t,excb3lyp,fb3lypn,fb3lypdn
  real(kind=8):: rho(2),sigma(3),vrho(2),vsigma(3),w(3)

  integer:: i
  real(kind=8):: delta,eta,lambda

  type(xc_f90_pointer_t) :: xc_func
  type(xc_f90_pointer_t) :: xc_func2
  type(xc_f90_pointer_t) :: xc_info

  call xc_f90_func_init(xc_func,xc_info,XC_HYB_GGA_XC_B3LYP, XC_UNPOLARIZED)

  do i=1,np
     x = dble(i-1)/np
     pn(i,1) = cos(1.5d0*3.14d0*x)+1.0
     pn(i,2) = sin(1.5d0*3.14d0*x)+1.0
     pdn(i,1) = -1.5d0*3.14d0*sin(1.5d0*3.14d0*x)
     pdn(i,2) = 1.5d0*3.14d0*cos(1.5d0*3.14d0*x)
     !pn(i,1) = 0.75d0
     !pn(i,2) = 0.25d0
     !pdn(i,1) = 0.0d0
     !pdn(i,2) = 0.0d0
     !pn(i,1) = sin(3.14d0*x)+1.0
     !pn(i,2) = pn(i,1)
     !pdn(i,1) = 3.14d0*cos(3.14d0*x)
     !pdn(i,2) = pdn(i,1)

     adn(i) = sqrt(pdn(i,1)**2+pdn(i,2)**2+2.0d0*pdn(i,1)*pdn(i,2)*0.5d0)

     apdn(i,1) = abs(pdn(i,1))
     apdn(i,2) = abs(pdn(i,2))
  end do

  call b3lyp_exchcor(np,pn(1,1),apdn(1,1),exc,pfxcn(1,1),pfxcdn(1,1),0)
  call b3lyp_x_exchcor(np,pn(1,1),apdn(1,1),excx,pfxcnx(1,1),pfxcdnx(1,1),0)
  exc = exc - excx
  pfxcn = pfxcn - pfxcnx
  pfxcdn = pfxcdn - pfxcdnx
  delta = 0.0d0
  eta = 0.0d0
  lambda = 0.0d0
  do i=2,np-1
     call xc_f90_gga_exc_vxc(xc_func,1,pn(i,1),apdn(i,1)**2,excb3lyp, &
          fb3lypn,fb3lypdn)
     fb3lypdn=fb3lypdn*apdn(i,1)*2.0d0
     write(6,'(7(1x,e18.11))') pn(i,1),exc(i),exc(i)-excb3lyp, &
          pfxcn(i,1),pfxcn(i,1)-fb3lypn,pfxcdn(i,1),pfxcdn(i,1)-fb3lypdn
     delta = max(delta, abs(exc(i)-excb3lyp))
     eta = max(eta, abs(pfxcn(i,1)-fb3lypn))
     lambda = max(lambda, abs(pfxcdn(i,1)-fb3lypdn))
  end do
  write(6,*) '# ', delta,eta,lambda

  call xc_f90_func_end(xc_func)
  call xc_f90_func_init(xc_func2,xc_info,XC_HYB_GGA_XC_B3LYP, XC_POLARIZED)

  write(6,*)
  write(6,*) '# nspin = 2'
  call b3lyp_exchcorsp(np,pn,apdn,adn,excsp,pfxcn,pfxcdn,fxcdn,0)
  call b3lyp_x_exchcorsp(np,pn,apdn,adn,excspx,pfxcnx,pfxcdnx,fxcdnx,0)
  excsp = excsp - excspx
  pfxcn = pfxcn - pfxcnx
  pfxcdn = pfxcdn - pfxcdnx

  delta = 0.0d0
  eta = 0.0d0
  lambda = 0.0d0
  rho = 0.0d0
  vrho = 0.0d0
  excb3lyp = 0.0d0
  do i=1,np
     rho(1) = pn(i,1)
     rho(2) = pn(i,2)
     sigma(1) = apdn(i,1)**2
     sigma(2) = 0.5d0*( adn(i)**2 - apdn(i,1)**2 - apdn(i,2)**2 )
     sigma(3) = apdn(i,2)**2
     call xc_f90_gga_exc_vxc(xc_func2,1,rho(1),sigma(1),t, &
          vrho(1),vsigma(1))
     excb3lyp = excb3lyp + t*(rho(1)+rho(2))
     w(1) = vsigma(1)*apdn(i,1)*2.0d0 - vsigma(2)*apdn(i,1)
     w(2) = vsigma(3)*apdn(i,2)*2.0d0 - vsigma(2)*apdn(i,2)
     w(3) = vsigma(2)*adn(i)
     write(6,'(2(1x,e18.11),10(1x,e11.4))') pn(i,1),pn(i,2), &
          pfxcn(i,1),pfxcn(i,1)-vrho(1), &
          pfxcn(i,2),pfxcn(i,2)-vrho(2), &
          pfxcdn(i,1),pfxcdn(i,1)-w(1), &
          pfxcdn(i,2),pfxcdn(i,2)-w(2), &
          fxcdn(i),fxcdn(i)-w(3)
     eta = max(eta, abs(pfxcn(i,1)-vrho(1)))
     lambda = max(lambda, abs(pfxcdn(i,1)-w(1)))
  end do
  write(6,*) '# ',excsp,(excsp-excb3lyp)/excsp
  write(6,*) '# ',eta,lambda
  call xc_f90_func_end(xc_func2)

end program test
