!
! Copyright (c) 2000-2013 Yoshihide Yoshimoto
!
program test
  use pbesol_xcgga
  implicit none
  integer,parameter:: np = 8000
  real(kind=8):: pn(np,2),pdn(np,2),pfxcn(np,2),pfxcdn(np,2)
  real(kind=8):: pfxn(np,2),pfxdn(np,2),fcn(np),fczeton(np),fcdn(np)
  real(kind=8):: apdn(np,2),adn(np)
  real(kind=8):: dn(np),vxc(2),vx(2),vc(2),x,exc(np)
  real(kind=8):: delgrup,uplap,agrdn,delgrdn, &
       dnlap, agr, delgr, lcor, &
       lpot, exlsd,vxuplsd,vxdnlsd,eclsd,vcuplsd,vcdnlsd, &
       expw91,vxuppw91,vxdnpw91,ecpw91,vcuppw91,vcdnpw91, &
       expbe,vxuppbe,vxdnpbe,ecpbe,vcuppbe,vcdnpbe, &
       exsol,vxupsol,vxdnsol,ecsol,vcupsol,vcdnsol

  integer:: i, imax
  real(kind=8):: delta,zeta

  do i=1,np
     x = dble(i-1)/np
     pn(i,1) = cos(1.5d0*3.14d0*x)+1.0
     pn(i,2) = sin(1.5d0*3.14d0*x)+1.0
     pdn(i,1) = -1.5d0*3.14d0*sin(1.5d0*3.14d0*x)
     pdn(i,2) = 1.5d0*3.14d0*cos(1.5d0*3.14d0*x)
     !pn(i,1) = 0.75d0
     !pn(i,2) = 0.25d0
     !pdn(i,1) = 0.0d0
     !pdn(i,2) = 0.0d0
     !pn(i,1) = sin(3.14d0*x)+1.0
     !pn(i,2) = pn(i,1)
     !pdn(i,1) = 3.14d0*cos(3.14d0*x)
     !pdn(i,2) = pdn(i,1)

     dn(i) = pdn(i,1)+pdn(i,2)

     apdn(i,1) = abs(pdn(i,1))
     apdn(i,2) = abs(pdn(i,2))
     adn(i) = abs(dn(i))
  end do
  call pbesol_exchcorsp(np,pn,apdn,adn,exc(1),pfxcn,pfxdn,fcdn,1)

  delta = 0.0d0
  do i=2,np-1
     x = dble(i-1)/np
     vxc(1) = pfxcn(i,1) - (pfxdn(i+1,1)*sign(1.0d0,pdn(i+1,1))-pfxdn(i-1,1)*sign(1.0d0,pdn(i-1,1)))/(2.0d0/np) - (fcdn(i+1)*sign(1.0d0,dn(i+1))-fcdn(i-1)*sign(1.0d0,dn(i-1)))/(2.0d0/np)
     vxc(2) = pfxcn(i,2) - (pfxdn(i+1,2)*sign(1.0d0,pdn(i+1,2))-pfxdn(i-1,2)*sign(1.0d0,pdn(i-1,2)))/(2.0d0/np) - (fcdn(i+1)*sign(1.0d0,dn(i+1))-fcdn(i-1)*sign(1.0d0,dn(i-1)))/(2.0d0/np)
     zeta = (pn(i,1)-pn(i,2))/(pn(i,1)+pn(i,2))
     delgrup = pdn(i,1)*(apdn(i+1,1)-apdn(i-1,1))/(2.0d0/np)
     uplap = (pn(i+1,1)+pn(i-1,1)-2.0d0*pn(i,1))/(1.0d0/np)**2
     delgrdn = pdn(i,2)*(apdn(i+1,2)-apdn(i-1,2))/(2.0d0/np)
     dnlap = (pn(i+1,2)+pn(i-1,2)-2.0d0*pn(i,2))/(1.0d0/np)**2
     delgr = dn(i)*(adn(i+1)-adn(i-1))/(2.0d0/np)
     call easysol(pn(i,1),apdn(i,1),delgrup,uplap, &
          pn(i,2),apdn(i,2),delgrdn,dnlap, &
          adn(i),delgr,1,1, &
          exlsd,vxuplsd,vxdnlsd,eclsd,vcuplsd,vcdnlsd, &
          expw91,vxuppw91,vxdnpw91,ecpw91,vcuppw91,vcdnpw91, &
          expbe,vxuppbe,vxdnpbe,ecpbe,vcuppbe,vcdnpbe, &
          exsol,vxupsol,vxdnsol,ecsol,vcupsol,vcdnsol)
     if (delta .lt. abs(vxc(1)-vxupsol-vcupsol)) then
        imax = i
        delta = abs(vxc(1)-vxupsol-vcupsol)
     end if
     if (delta .lt. abs(vxc(2)-vxdnsol-vcdnsol)) then
        imax = i
        delta = abs(vxc(2)-vxdnsol-vcdnsol)
     end if
  write(6,*) vxc(1)-vxupsol-vcupsol, vxc(2)-vxdnsol-vcdnsol
  end do
  write(6,*) delta, imax

  call pbesol_exchcor(np,pn(1,1),apdn(1,1),exc,pfxcn(1,1),pfxcdn(1,1),1)
  delta = 0.0d0
  do i=2,np-1
     vxc(1) = pfxcn(i,1) - (pfxcdn(i+1,1)*sign(1.0d0,pdn(i+1,1))-pfxcdn(i-1,1)*sign(1.0d0,pdn(i-1,1)))/(2.0d0/np)
     delgrup = 0.25d0*pdn(i,1)*(apdn(i+1,1)-apdn(i-1,1))/(2.0d0/np)
     uplap = 0.5d0*(pn(i+1,1)+pn(i-1,1)-2.0d0*pn(i,1))/(1.0d0/np)**2
     delgrdn = delgrup
     dnlap = uplap
     delgr = pdn(i,1)*(apdn(i+1,1)-apdn(i-1,1))/(2.0d0/np)
     call easysol(0.5d0*pn(i,1),0.5d0*apdn(i,1),delgrup,uplap, &
          0.5d0*pn(i,1),0.5d0*apdn(i,1),delgrdn,dnlap, &
          apdn(i,1),delgr,1,1, &
          exlsd,vxuplsd,vxdnlsd,eclsd,vcuplsd,vcdnlsd, &
          expw91,vxuppw91,vxdnpw91,ecpw91,vcuppw91,vcdnpw91, &
          expbe,vxuppbe,vxdnpbe,ecpbe,vcuppbe,vcdnpbe, &
          exsol,vxupsol,vxdnsol,ecsol,vcupsol,vcdnsol)
     delta = max(delta, abs(vxc(1)-(vxupsol+vcupsol)))
  end do
  write(6,*) delta
end program test
